---
title: Object
slug: Web/JavaScript/Reference/Global_Objects/Object
tags:
  - Class
  - JavaScript
  - Object
---
<div>{{JSRef}}</div>

<p>The <code><strong>Object</strong></code> class represents one of <a href="/en-US/docs/Web/JavaScript/Data_structures">JavaScript's data types</a>. It is used to store various keyed collections and more complex entities. Objects can be created using the {{jsxref("Object/Object", "Object()")}} constructor or the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Object_initializer">object initializer / literal syntax</a>.</p>

<h2 id="Description">Description</h2>

<p>Nearly all objects in JavaScript are instances of {{jsxref("Object")}}; a typical object inherits properties (including methods) from <code>Object.prototype</code>, although these properties may be shadowed (a.k.a. overridden). However, an <code>Object</code> may be deliberately created for which this is not true (e.g. by {{jsxref("Object.create", "Object.create(null)")}}), or it may be altered so that this is no longer true (e.g. with {{jsxref("Object.setPrototypeOf")}}).</p>

<p>Changes to the <code>Object</code> prototype object are seen by <strong>all</strong> objects through prototype chaining, unless the properties and methods subject to those changes are overridden further along the prototype chain. This provides a very powerful although potentially dangerous mechanism to override or extend object behavior.</p>

<p>The <code>Object</code> constructor creates an object wrapper for the given value.</p>

<ul>
 <li>If the value is {{jsxref("null")}} or {{jsxref("undefined")}}, it will create and return an empty object.</li>
 <li>Otherwise, it will return an object of a Type that corresponds to the given value.</li>
 <li>If the value is an object already, it will return the value.</li>
</ul>

<p>When called in a non-constructor context, <code>Object</code> behaves identically to <code>new Object()</code>.</p>

<p>See also the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Object_initializer">object initializer / literal syntax</a>.</p>

<h3 id="Deleting_a_property_from_an_object">Deleting a property from an object</h3>

<p>There isn't any method in an Object itself to delete its own properties (such as {{jsxref("Map.prototype.delete", "Map.prototype.delete()")}}). To do so, one must use the <a href="/en-US/docs/Web/JavaScript/Reference/Operators/delete">delete operator</a>.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{jsxref("Object/Object", "Object()")}}</dt>
 <dd>Creates a new <code>Object</code> object. It is a wrapper for the given value.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<dl>
 <dt>{{jsxref("Object.assign","Object.assign()")}}</dt>
 <dd>Copies the values of all enumerable own properties from one or more source objects to a target object.</dd>
 <dt>{{jsxref("Object.create","Object.create()")}}</dt>
 <dd>Creates a new object with the specified prototype object and properties.</dd>
 <dt>{{jsxref("Object.defineProperty","Object.defineProperty()")}}</dt>
 <dd>Adds the named property described by a given descriptor to an object.</dd>
 <dt>{{jsxref("Object.defineProperties","Object.defineProperties()")}}</dt>
 <dd>Adds the named properties described by the given descriptors to an object.</dd>
 <dt>{{jsxref("Object.entries","Object.entries()")}}</dt>
 <dd>Returns an array containing all of the <code>[key, value]</code> pairs of a given object's <strong>own</strong> enumerable string properties.</dd>
 <dt>{{jsxref("Object.freeze","Object.freeze()")}}</dt>
 <dd>Freezes an object. Other code cannot delete or change its properties.</dd>
 <dt>{{jsxref("Object.fromEntries","Object.fromEntries()")}}</dt>
 <dd>Returns a new object from an iterable of <code>[key, value]</code> pairs. (This is the reverse of {{jsxref("Object.entries")}}).</dd>
 <dt>{{jsxref("Object.getOwnPropertyDescriptor","Object.getOwnPropertyDescriptor()")}}</dt>
 <dd>Returns a property descriptor for a named property on an object.</dd>
 <dt>{{jsxref("Object.getOwnPropertyDescriptors","Object.getOwnPropertyDescriptors()")}}</dt>
 <dd>Returns an object containing all own property descriptors for an object.</dd>
 <dt>{{jsxref("Object.getOwnPropertyNames","Object.getOwnPropertyNames()")}}</dt>
 <dd>Returns an array containing the names of all of the given object's <strong>own</strong> enumerable and non-enumerable properties.</dd>
 <dt>{{jsxref("Object.getOwnPropertySymbols","Object.getOwnPropertySymbols()")}}</dt>
 <dd>Returns an array of all symbol properties found directly upon a given object.</dd>
 <dt>{{jsxref("Object.getPrototypeOf","Object.getPrototypeOf()")}}</dt>
 <dd>Returns the prototype (internal <code>[[Prototype]]</code> property) of the specified object.</dd>
 <dt>{{jsxref("Object.is","Object.is()")}}</dt>
 <dd>Compares if two values are the same value. Equates all <code>NaN</code> values (which differs from both Abstract Equality Comparison and Strict Equality Comparison).</dd>
 <dt>{{jsxref("Object.isExtensible","Object.isExtensible()")}}</dt>
 <dd>Determines if extending of an object is allowed.</dd>
 <dt>{{jsxref("Object.isFrozen","Object.isFrozen()")}}</dt>
 <dd>Determines if an object was frozen.</dd>
 <dt>{{jsxref("Object.isSealed","Object.isSealed()")}}</dt>
 <dd>Determines if an object is sealed.</dd>
 <dt>{{jsxref("Object.keys","Object.keys()")}}</dt>
 <dd>Returns an array containing the names of all of the given object's <strong>own</strong> enumerable string properties.</dd>
 <dt>{{jsxref("Object.preventExtensions","Object.preventExtensions()")}}</dt>
 <dd>Prevents any extensions of an object.</dd>
 <dt>{{jsxref("Object.seal","Object.seal()")}}</dt>
 <dd>Prevents other code from deleting properties of an object.</dd>
 <dt>{{jsxref("Object.setPrototypeOf","Object.setPrototypeOf()")}}</dt>
 <dd>Sets the object's prototype (its internal <code>[[Prototype]]</code> property).</dd>
 <dt>{{jsxref("Object.values","Object.values()")}}</dt>
 <dd>Returns an array containing the values that correspond to all of a given object's <strong>own</strong> enumerable string properties.</dd>
</dl>

<h2 id="Instance_properties">Instance properties</h2>

<dl>
 <dt>{{jsxref("Object.prototype.constructor")}}</dt>
 <dd>Specifies the function that creates an object's prototype.</dd>
 <dt>{{jsxref("Object.prototype.__proto__")}}</dt>
 <dd>Points to the object which was used as prototype when the object was instantiated.</dd>
 <dt>{{jsxref("Object.prototype.__noSuchMethod__")}}</dt>
 <dd>Allows a function to be defined that will be executed when an undefined object member is called as a method.</dd>
</dl>

<h2 id="Instance_methods">Instance methods</h2>

<dl>
 <dt>{{jsxref("Object.prototype.__defineGetter__()")}}</dt>
 <dd>Associates a function with a property that, when accessed, executes that function and returns its return value.</dd>
 <dt>{{jsxref("Object.prototype.__defineSetter__()")}}</dt>
 <dd>Associates a function with a property that, when set, executes that function which modifies the property.</dd>
 <dt>{{jsxref("Object.prototype.__lookupGetter__()")}}</dt>
 <dd>Returns the function associated with the specified property by the {{jsxref("Object.prototype.__defineGetter__()", "__defineGetter__()")}} method.</dd>
 <dt>{{jsxref("Object.prototype.__lookupSetter__()")}}</dt>
 <dd>Returns the function associated with the specified property by the {{jsxref("Object.prototype.__defineSetter__()", "__defineSetter__()")}} method.</dd>
 <dt>{{jsxref("Object.prototype.hasOwnProperty()")}}</dt>
 <dd>Returns a boolean indicating whether an object contains the specified property as a direct property of that object and not inherited through the prototype chain.</dd>
 <dt>{{jsxref("Object.prototype.isPrototypeOf()")}}</dt>
 <dd>Returns a boolean indicating whether the object this method is called upon is in the prototype chain of the specified object.</dd>
 <dt>{{jsxref("Object.prototype.propertyIsEnumerable()")}}</dt>
 <dd>Returns a boolean indicating if the internal <a href="/en-US/docs/Web/JavaScript/Data_structures#Properties">ECMAScript [[Enumerable]] attribute</a> is set.</dd>
 <dt>{{jsxref("Object.prototype.toLocaleString()")}}</dt>
 <dd>Calls {{jsxref("Object.toString", "toString()")}}.</dd>
 <dt>{{jsxref("Object.prototype.toString()")}}</dt>
 <dd>Returns a string representation of the object.</dd>
 <dt>{{jsxref("Object.prototype.unwatch()")}}</dt>
 <dd>Removes a watchpoint from a property of the object.</dd>
 <dt>{{jsxref("Object.prototype.valueOf()")}}</dt>
 <dd>Returns the primitive value of the specified object.</dd>
 <dt>{{jsxref("Object.prototype.watch()")}}</dt>
 <dd>Adds a watchpoint to a property of the object.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Object_given_undefined_and_null_types">Using <code>Object</code> given <code>undefined</code> and <code>null</code> types</h3>

<p>The following examples store an empty <code>Object</code> object in <code>o</code>:</p>

<pre class="brush: js">let o = new Object()
</pre>

<pre class="brush: js">let o = new Object(undefined)
</pre>

<pre class="brush: js">let o = new Object(null)
</pre>

<h3 id="Using_Object_to_create_Boolean_objects">Using <code>Object</code> to create <code>Boolean</code> objects</h3>

<p>The following examples store {{jsxref("Boolean")}} objects in <code>o</code>:</p>

<pre class="brush: js">// equivalent to o = new Boolean(true)
let o = new Object(true)
</pre>

<pre class="brush: js">// equivalent to o = new Boolean(false)
let o = new Object(Boolean())
</pre>

<h3 id="Object_prototypes">Object prototypes</h3>

<p>When altering the behavior of existing <code>Object.prototype</code> methods, consider injecting code by wrapping your extension before or after the existing logic. For example, this (untested) code will pre-conditionally execute custom logic before the built-in logic or someone else's extension is executed.</p>

<p>When a function is called, the arguments to the call are held in the array-like "variable" <a href="/en-US/docs/Web/JavaScript/Reference/Functions/arguments">arguments</a>. For example, in the call <code>myFn(a, b, c)</code>, the arguments within <code>myFn</code>'s body will contain 3 array-like elements corresponding to <code>(a, b, c)</code>.</p>

<p>When modifying prototypes with hooks, pass <code>this</code> and the arguments (the call state) to the current behavior by calling <code>apply()</code> on the function. This pattern can be used for any prototype, such as <code>Node.prototype</code>, <code>Function.prototype</code>, etc.</p>

<pre class="brush: js">var current = Object.prototype.valueOf;

// Since my property "-prop-value" is cross-cutting and isn't always
// on the same prototype chain, I want to modify Object.prototype:
Object.prototype.valueOf = function() {
  if (this.hasOwnProperty('-prop-value')) {
    return this['-prop-value'];
  } else {
    // It doesn't look like one of my objects, so let's fall back on
    // the default behavior by reproducing the current behavior as best we can.
    // The apply behaves like "super" in some other languages.
    // Even though valueOf() doesn't take arguments, some other hook may.
    return current.apply(this, arguments);
  }
}
</pre>

<p>Since JavaScript doesn't exactly have sub-class objects, prototype is a useful workaround to make a “base class” object of certain functions that act as objects. For example:</p>

<pre class="brush: js">var Person = function(name) {
  this.name = name;
  this.canTalk = true;
};

Person.prototype.greet = function() {
  if (this.canTalk) {
    console.log('Hi, I am ' + this.name);
  }
};

var Employee = function(name, title) {
  Person.call(this, name);
  this.title = title;
};

Employee.prototype = Object.create(Person.prototype);
Employee.prototype.constructor = Employee; //If you don't set Object.prototype.constructor to Employee,
                                           //it will take prototype.constructor of Person (parent).
                                           //To avoid that, we set the prototype.constructor to Employee (child).

Employee.prototype.greet = function() {
  if (this.canTalk) {
    console.log('Hi, I am ' + this.name + ', the ' + this.title);
  }
};

var Customer = function(name) {
  Person.call(this, name);
};

Customer.prototype = Object.create(Person.prototype);
Customer.prototype.constructor = Customer; //If you don't set Object.prototype.constructor to Customer,
                                           //it will take prototype.constructor of Person (parent).
                                           //To avoid that, we set the prototype.constructor to Customer (child).

var Mime = function(name) {
  Person.call(this, name);
  this.canTalk = false;
};

Mime.prototype = Object.create(Person.prototype);
Mime.prototype.constructor = Mime; //If you don't set Object.prototype.constructor to Mime,
                                   //it will take prototype.constructor of Person (parent).
                                   //To avoid that, we set the prototype.constructor to Mime (child).

var bob = new Employee('Bob', 'Builder');
var joe = new Customer('Joe');
var rg = new Employee('Red Green', 'Handyman');
var mike = new Customer('Mike');
var mime = new Mime('Mime');

bob.greet();
// Hi, I am Bob, the Builder

joe.greet();
// Hi, I am Joe

rg.greet();
// Hi, I am Red Green, the Handyman

mike.greet();
// Hi, I am Mike

mime.greet();</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-object-objects', 'Object')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external" href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("javascript.builtins.Object")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/Object_initializer">Object initializer</a></li>
</ul>
